package org.gcube.portlets.widgets.ckandatapublisherwidget.client;

import java.util.List;

import org.gcube.common.homelibrary.home.HomeLibrary;
import org.gcube.common.homelibrary.home.exceptions.HomeNotFoundException;
import org.gcube.common.homelibrary.home.exceptions.InternalErrorException;
import org.gcube.common.homelibrary.home.exceptions.UserNotFoundException;
import org.gcube.common.homelibrary.home.workspace.Workspace;
import org.gcube.common.homelibrary.home.workspace.WorkspaceFolder;
import org.gcube.common.homelibrary.home.workspace.WorkspaceItem;
import org.gcube.common.homelibrary.home.workspace.catalogue.WorkspaceCatalogue;
import org.gcube.common.homelibrary.home.workspace.exceptions.ItemNotFoundException;
import org.gcube.common.homelibrary.home.workspace.exceptions.WorkspaceFolderNotFoundException;
import org.gcube.common.scope.api.ScopeProvider;
import org.gcube.portlets.widgets.ckandatapublisherwidget.server.CKANPublisherServicesImpl;


public class TestClass {

	//@Test
	public void testUser() {

		assert(new CKANPublisherServicesImpl().getDevelopmentUser().equals(CKANPublisherServicesImpl.TEST_USER));

	}

	//@Test
	public void testCopyResources() throws WorkspaceFolderNotFoundException, InternalErrorException, HomeNotFoundException, UserNotFoundException, ItemNotFoundException{

		ScopeProvider.instance.set("/gcube/devNext/NextNext");

		Workspace ws = HomeLibrary
				.getHomeManagerFactory()
				.getHomeManager()
				.getHome("costantino.perciante").getWorkspace();

		WorkspaceItem originalFolder = ws.getItem("d3a37eb9-1589-4c95-a9d0-c473a02d4f0f");

		List<? extends WorkspaceItem> children = originalFolder.getChildren();
		//		System.out.println("Folder  is " + originalFolder.getName());
		//		for (WorkspaceItem workspaceItem : children) {
		//			System.out.println("Child is " + workspaceItem.getName());
		//		}

		// copy to catalogue
		WorkspaceCatalogue userCatalogue = ws.getCatalogue();

		WorkspaceItem copiedFolder = userCatalogue.addWorkspaceItem(originalFolder.getId(), userCatalogue.getId());
		System.out.println(copiedFolder.isHidden());
		//		for (WorkspaceItem workspaceItem : children) {
		//			WorkspaceItem copiedChildren = userCatalogue.addWorkspaceItem(workspaceItem.getId(), copiedFolder.getId());
		//			System.out.println("****************************** Copied file has path " + copiedChildren.getPath());
		//		}

		// look at catalogue structure
		List<WorkspaceItem> catalogueChildrens = ((WorkspaceFolder)userCatalogue).getChildren(true);
		if(catalogueChildrens.isEmpty())
			System.out.println("****************************** Catalogue Child list is empty");
		else for (WorkspaceItem catalogueItem : catalogueChildrens) {
			System.out.println("****************************** Catalogue Child is " + catalogueItem.getName());
			if(catalogueItem.isFolder()){
				WorkspaceFolder catalogueFolder = (WorkspaceFolder) catalogueItem;
				System.out.println("**************************" + catalogueFolder.getName() + " it is a folder, printing children");
				List<? extends WorkspaceItem> copiedFolderChildren = catalogueFolder.getChildren(true);
				for (WorkspaceItem copiedFolderChildrenItem : copiedFolderChildren) {
					System.out.println("****************************** Child is " + copiedFolderChildrenItem.getName());
					copiedFolderChildrenItem.getPublicLink(true);
				}
			}
		}
	}

	//@Test
	public void testTitle(){

		//		String regexTitleSubWord = "[^a-zA-Z0-9_.-]";
		//		String title = "this is a test title .";
		//		String[] splittedTitle = title.split(" ");
		//
		//		for (String word : splittedTitle) {
		//			System.out.println("Word is " + word);
		//			String replaced = word.replaceAll(regexTitleSubWord, "");	
		//			System.out.println("Replaced Word is " + replaced);
		//			if(!replaced.equals(word)){
		//				System.out.println("Please note that only alphanumeric characters are allowed for the title");
		//			}
		//		}

		System.out.println("Notification_portlet".replaceAll("[^A-Za-z0-9.-_]", " "));
	}

}
